###############################################################################
# ViewGroups.pl                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.5 Anniversary Edition                                #
# Packaged:       July 04, 2010                                               #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2010 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$viewgroupsplver = 'YaBB 2.5 AE $Revision: 0.1 $';

sub ViewGroups {

    if (!$INFO{'title'} || !$allow_view_groups || ($iamguest && $allow_view_groups != 1) || ($allow_view_groups == 3 && !$iamadmin && !$iamgmod && !$iammod) || ($allow_view_groups == 4 && !$iamadmin && !$iamgmod) || ($allow_view_groups == 5 && !$iamadmin)) { &fatal_error('no_access'); }
    
    &LoadLanguage('MemberList');

    $group_title = $INFO{'title'};
    $no_post_id  = $INFO{'gid'};
    $group_title =~ s/_/ /g;
    
    unless ((exists $Group{$group_title}) || (exists $NoPost{$no_post_id})) { &fatal_error('no_group_exists'); }

    &ManageMemberinfo("load");
    my $show_group = "";
    $member_count = 0;
    $colspan = 2;
	
    foreach $membername (sort { lc $memberinf{$a} cmp lc $memberinf{$b} } keys %memberinf) {
        (undef, undef, $memposition, undef, $memaddgroups) = split(/\|/, $memberinf{$membername});
        my $add_group_title = 0;
        foreach $addgrptitle (split(/,/, $memaddgroups)) {
            if (($addgrptitle eq $group_title) || ($addgrptitle eq $no_post_id)) {
                 $add_group_title = 1;
            }
        }
        if (($memposition eq $group_title) || ($memposition eq $no_post_id) || $add_group_title) {
            &LoadUser($membername);
            if ($allowpics) { 
                if (${$uid.$membername}{'userpic'} eq "blank.gif") { ${$uid.$membername}{'userpic'} = "nn.gif"; }
                $userpic = qq~<td class="windowbg" style="width: ${max_avatar_width}px; text-align: center;"><a href="$scripturl?action=viewprofile;username=$useraccount{$membername}"><img src="~ .(${$uid.$membername}{'userpic'} =~ m~\A[\s\n]*https?://~i ? ${$uid.$membername}{'userpic'} : "$facesurl/${$uid.$membername}{'userpic'}") . qq~" name="avatar_img_resize" alt="" border="0" style="display: none" /></a></td>~; 
            } else { 
                $userpic = ""; 
                $colspan = 1;
            }
            my $show_add_groups;
            if (${$uid.$membername}{'addgroups'}) {
                $show_add_group = $addmembergroup{$membername};
                $show_add_group =~ s/<br \/>/\, /g;
                $show_add_group =~ s/\A, //;
                $show_add_group =~ s/, \Z//;
                $show_add_groups = qq~<br /><span class="small"><b>$ml_txt{'add_groups'}</b> $show_add_group</span>~;
            }
            $member_position = "";
            $member_title = $memberinfo{$membername};
            $member_title =~ s/<b>//;
            $member_title =~ s/<\/b>//;
            if ($add_group_title) { $member_position = qq~<br /><span class="small"><b>$ml_txt{'87'}:</b> $member_title</span>~; }
            $member_count++;
            $show_group .= qq~
  <tr>
    $userpic
    <td class="windowbg2">
      $link{$membername}$member_position$show_add_groups
    </td>
  </tr>~;
        } 
    }
    undef %memberinf;
	
    if ($no_post_id) { ($grptitle, $starnum, $starimg, $groupcol) = split(/\|/, $NoPost{$no_post_id}); }
    else { ($grptitle, $starnum, $starimg, $groupcol) = split(/\|/, $Group{$group_title}); }
    my $starnums = $starnum;
    my $memberstartemp = "";
    if ($starimg !~ /\//) { $starimg = "$imagesdir/$starimg"; }
    while ($starnums-- > 0) {
        $memberstartemp .= qq~<img src="$starimg" alt="" border="0" />~;
    }
    $group_stars = $memberstartemp;
    if ($member_count == 0) {
        $colspan = 1;
        $show_group = qq~
  <tr>
    <td class="windowbg2">$ml_txt{'no_members'}</td>
  </tr>~;
    }
    
    $grptitle .= qq~ <span style="float: right;">$group_stars</span>~;

    $yymain = qq~
<table cellpadding="4" cellspacing="1" border="0" style="width: 100%; margin: 0 auto; background-color: $groupcol;">
  <tr>
    <td colspan="$colspan" class="titlebg" style="background: url($defaultimagesdir/catbg.png) $groupcol;">
      <img src="$imagesdir/profile.gif" alt="" border="0" style="vertical-align: middle;" /> $grptitle
    </td>
  </tr>~;
    if ($member_count > 0) {
        $yymain .= qq~
  <tr>
    <td colspan="$colspan" class="windowbg small"><b>$ml_txt{'total_members'}</b> $member_count</td>
  </tr>~; 
    }
    $yymain .= qq~
  $show_group
</table>~;

    $tabsep = qq~<img src="$imagesdir/tabsep211.png" border="0" alt="" style="vertical-align: middle;" />~;
    $yynavback = qq~$tabsep <a href="$scripturl">&#171; $img_txt{'103'}</a> $tabsep~;
    $yytitle = $ml_txt{'view_member_groups'};
    $yynavigation = qq~&rsaquo; $ml_txt{'view_member_groups'}~;

    &template;
    exit;

}

1;
