<id>
View Member Groups for YaBB 2.5
</id>

<version>
0.1
</version>

<mod info>
Description
-----------
This Mod will allow you to view which members are in which member group by clicking on the group names in the legend on the board index.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload ViewGroups.pl to the Sources directory in ASCII mode.
4) Go to Admin Center => Forum Settings => Members tab => MemberList to enable the setting.

Files to edit
-------------
Admin/ModList.pl
Admin/NewSettings.pl
Admin/Settings_Main.pl
Languages/English/Admin.lng
Languages/English/Error.lng
Languages/English/MemberList.lng
Sources/BoardIndex.pl
Sources/SubList.pl

Version History
---------------
0.1 - First Release - 9th May 2012
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$view_member_groups_mod = "View Member Groups|Derek Barnstorm|This Mod will allow you to view which members are in which member group by clicking on the group names in the legend on the board index.|0.1|9th May 2012";
	push (@installed_mods, "$view_member_groups_mod");
	
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$ML_Allowed = $ML_Allowed;				# allow browse MemberList
</search for>

<add after>
\$allow_view_groups = $allow_view_groups;    # Select who is allowed to view the member group list
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
			name => 'barmaxdepend',
			validate => 'boolean',
		},
</search for>

<add after>
		{
			description => qq~<label for="allow_view_groups">$admin_txt{'member_group_view'}</label>~,
			input_html => qq~
<select name="allow_view_groups" id="allow_view_groups">
  <option value="0" ${isselected($allow_view_groups == 0)}>$userlevel_txt{'none'}</option>
  <option value="1" ${isselected($allow_view_groups == 1)}>$userlevel_txt{'all'}</option>
  <option value="2" ${isselected($allow_view_groups == 2)}>$userlevel_txt{'members'}</option>
  <option value="3" ${isselected($allow_view_groups == 3)}>$userlevel_txt{'modgmodadmin'}</option>
  <option value="4" ${isselected($allow_view_groups == 4)}>$userlevel_txt{'gmodadmin'}</option>
  <option value="5" ${isselected($allow_view_groups == 4)}>$userlevel_txt{'admin'}</option>
</select>~,
			name => 'allow_view_groups',
			validate => 'number',
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
'member_group_view' => 'Select who is allowed to view the Member Group list:',
</add before>

<edit file>
Languages/English/Error.lng
</edit file>

<search for>
'newpostdep_gmod'		=> 'Sorry, Global Mods can\'t modify Postdependent users because the Maintenance->"Rebuild Memberlist" must be run after and that function is only available in Maintenance Mode, so it would deny your login!',
</search for>

<add after>
'no_group_exists'		=> 'The Member Group you are trying to view does not exist!',
</add after>

<edit file>
Languages/English/MemberList.lng
</edit file>

<search for>
);

1;
</search for>

<add before>
'view_member_groups' => 'View Member Groups',
'add_groups' => 'Additional Groups:',
'total_members' => 'Total members in this group:',
'no_members' => 'There are no members in this group yet.',
</add before>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	($title, undef, undef, $color, $noshow, undef) = split(/\|/, $Group{'Administrator'}, 6);
	if ($color && $noshow != 1) {
</search for>

<add after>
        $group_title = "Administrator";
        $group_title =~ s/ /_/g;
        if ($allow_view_groups == 1 || (!$iamguest && $allow_view_groups == 2) || ($allow_view_groups == 3 && $iamadmin || $iamgmod || $iammod) || ($allow_view_groups == 4 && $iamadmin || $iamgmod) || ($allow_view_groups == 5 && $iamadmin)) { 
            $title = qq~<a href="$scripturl?action=groups;title=$group_title">$title</a>~; 
        }
</add after>

<search for>
	($title, undef, undef, $color, $noshow, undef) = split(/\|/, $Group{'Global Moderator'}, 6);
	if ($color && $noshow != 1) {
</search for>

<add after>
        $group_title = $title;
        $group_title =~ s/ /_/g;	    
        if ($allow_view_groups == 1 || (!$iamguest && $allow_view_groups == 2) || ($allow_view_groups == 3 && $iamadmin || $iamgmod || $iammod) || ($allow_view_groups == 4 && $iamadmin || $iamgmod) || ($allow_view_groups == 5 && $iamadmin)) {  
            $title = qq~<a href="$scripturl?action=groups;title=$group_title">$title</a>~; 
        }
</add after>

<search for>
		($title, undef, undef, $color, $noshow, undef) = split(/\|/, $NoPost{$_}, 6);
		if ($color && $noshow != 1) {
</search for>

<add after>
            $group_title = $title;
            $group_title =~ s/ /_/g;
            if ($allow_view_groups == 1 || (!$iamguest && $allow_view_groups == 2) || ($allow_view_groups == 3 && $iamadmin || $iamgmod || $iammod) || ($allow_view_groups == 4 && $iamadmin || $iamgmod) || ($allow_view_groups == 5 && $iamadmin)) {  
                $title = qq~<a href="$scripturl?action=groups;title=$group_title;gid=$_">$title</a>~; 
            }
</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'findmember',"UserSelect.pl&FindMem",
</search for>

<add after>
'groups',"ViewGroups.pl&ViewGroups",
</add after>
















